#!/usr/bin/env python

import sys
import ao
import mp3file
import pcm
        

device = 'oss'
rate = 44100
ao = ao.AudioDevice("oss", bits=16, rate=rate)

size = 4806

f1 = mp3file.mp3file(sys.argv[1], rate)
f2 = mp3file.mp3file(sys.argv[2], rate)

mixingduration = 5
mixingratio = 0
mixingrate = 1.0/rate/mixingduration

while 1:
    buff1 = f1.read(size)
    buff2 = f2.read(size)

    print "%d:%02d" % divmod(int(f1.ptime/1000), 60), len(buff1), len(buff2) 
    sys.stdout.flush()

    if len(buff1)==0 or len(buff2)==0: break

    if len(buff1)!=len(buff2):
        if mixingratio>0.5:
            buff=buff1
        else:
            buff=buff2
    else:
        buff, mixingratio = pcm.mix(buff1, buff2, mixingratio, mixingrate)
        if mixingratio>=1 or mixingratio<=0:
            mixingrate *= -1

    ao.play(buff, len(buff))
