#!/usr/bin/env python

import mad
import ao
import sys
import mix

file1 = sys.argv[1]
file2 = sys.argv[2]
device = 'oss'
SIZE = 4806*1

f1 = mad.MadFile(file1)
f2 = mad.MadFile(file2)

ao = ao.AudioDevice("oss", bits=16)
mixingratio = 0

while 1:
    buff1 = f1.read()
    buff2 = f2.read()
    if len(buff1) == 0: break

    if mixingratio <1:
        mixingratio += 0.005 
    buff = mix.mix(buff1, buff2, mixingratio)

    ao.play(buff, len(buff))
